-- Author      : Weeperman
-- Create Date : 04/07/2011 16:30:22
-- locations c/o http://www.wowwiki.com/Archaeology_locations and http://www.wowpedia.org/Dig_sites

local DiggzTextArray = nil
local CurrentContinent = nil
local CurrentLookup = nil
local AreaTextureIndex = 5
local ArchaeologyTextureIndex = 177
local MFlapperTextureIndex = 178
local HFlapperTextureIndex = 179
local AFlapperTextureIndex = 180

local ArchLocations = nil
local AreaLocations = nil
local FlapperLocations = nil

local ContK =  "Kalimdor"
local ContEK = "Eastern Kingdoms"
local ContO =  "Outland"
local ContN =  "Northrend"

function Diggz_WhereAmI()

    local Continent = nil
    local cont = GetCurrentMapContinent()
    
        if (cont == 1) then Continent = ContK
    elseif (cont == 2) then Continent = ContEK        
    elseif (cont == 3) then Continent = ContO
    elseif (cont == 4) then Continent = ContN
    else 
        Continent = nil
    end   
    return Continent    
end

function NewLookup(loc)
    if (loc == ContK) then
        local ContKLookup = 
        {
            ["Ruins of Arkkoran"]={["zone"]="Azshara",["type"]="Night Elf"},
            ["Ruins of Eldarath"]={["zone"]="Azshara",["type"]="Night Elf"},
            ["Nazj'vel Digsite"]={["zone"]="Darkshore",["type"]="Night Elf"},
            ["Nightmare Scar Digsite"]={["zone"]="Southern Barrens",["type"]="Night Elf"},
            ["Bael Modan Digsite"]={["zone"]="Southern Barrens",["type"]="Dwarf"},
            ["Fields of Blood Fossil Bank"]={["zone"]="Southern Barrens",["type"]="Fossil"},
            ["Kodo Graveyard"]={["zone"]="Desolace",["type"]="Fossil"},
            ["Sargeron Digsite"]={["zone"]="Desolace",["type"]="Night Elf"},
            ["Slitherblade Shore Digsite"]={["zone"]="Desolace",["type"]="Night Elf"},
            ["Ethel Rethor Digsite"]={["zone"]="Desolace",["type"]="Night Elf"},
            ["Mannoroc Coven Digsite"]={["zone"]="Desolace",["type"]="Night Elf"},
            ["Valley of Bones"]={["zone"]="Desolace",["type"]="Fossil"},
            ["Darkmist Digsite"]={["zone"]="Feralas",["type"]="Night Elf"},
            ["Ravenwind Digsite"]={["zone"]="Feralas",["type"]="Night Elf"},
            ["North Isildien Digsite"]={["zone"]="Feralas",["type"]="Night Elf"},
            ["South Isildien Digsite"]={["zone"]="Feralas",["type"]="Night Elf"},
            ["Dire Maul Digsite"]={["zone"]="Feralas",["type"]="Night Elf"},
            ["Broken Commons Digsite"]={["zone"]="Feralas",["type"]="Night Elf"},
            ["Solarsal Digsite"]={["zone"]="Feralas",["type"]="Night Elf"},
            ["Oneiros Digsite"]={["zone"]="Feralas",["type"]="Night Elf"},
            ["Constellas Digsite"]={["zone"]="Felwood",["type"]="Night Elf"},
            ["Ironwood Digsite"]={["zone"]="Felwood",["type"]="Night Elf"},
            ["Jaedenar Digsite"]={["zone"]="Felwood",["type"]="Night Elf"},
            ["Morlos'Aran Digsite"]={["zone"]="Felwood",["type"]="Night Elf"},
            ["Zul'Farrak Digsite"]={["zone"]="Tanaris",["type"]="Troll"},
            ["Eastmoon Ruins Digsite"]={["zone"]="Tanaris",["type"]="Troll"},
            ["Dunemaul Fossil Ridge"]={["zone"]="Tanaris",["type"]="Fossil"},
            ["Southmoon Ruins Digsite"]={["zone"]="Tanaris",["type"]="Troll"},
            ["Broken Pillar Digsite"]={["zone"]="Tanaris",["type"]="Troll"},
            ["Abyssal Sands Fossil Ridge"]={["zone"]="Tanaris",["type"]="Fossil"},
            ["Lower Lakkari Tar Pits"]={["zone"]="Un'Goro Crater",["type"]="Fossil"},
            ["Upper Lakkari Tar Pits"]={["zone"]="Un'Goro Crater",["type"]="Fossil"},
            ["Marshlands Fossil Bank"]={["zone"]="Un'Goro Crater",["type"]="Fossil"},
            ["Screaming Reaches Fossil Field"]={["zone"]="Un'Goro Crater",["type"]="Fossil"},
            ["Terror Run Fossil Field"]={["zone"]="Un'Goro Crater",["type"]="Fossil"},
            ["Southwind Village Digsite"]={["zone"]="Silithus",["type"]="Night Elf"},
            ["Shrine of Goldrinn Digsite"]={["zone"]="Mount Hyjal",["type"]="Night Elf"},
            ["Sanctuary of Malorne Digsite"]={["zone"]="Mount Hyjal",["type"]="Night Elf"},
            ["Grove of Aessina Digsite"]={["zone"]="Mount Hyjal",["type"]="Night Elf"},
            ["Scorched Plain Digsite"]={["zone"]="Mount Hyjal",["type"]="Night Elf"},
            ["Ruins of Lar'donir Digsite"]={["zone"]="Mount Hyjal",["type"]="Night Elf"},
            ["Tombs of the Precursors Digsite"]={["zone"]="Uldum",["type"]="Tol'vir"},
            ["Ruins of Ammon Digsite"]={["zone"]="Uldum",["type"]="Tol'vir"},
            ["Ruins of Ahmtul Digsite"]={["zone"]="Uldum",["type"]="Tol'vir"},
            ["Ruins of Khintaset Digsite"]={["zone"]="Uldum",["type"]="Tol'vir"},
            ["Khartut's Tomb Digsite"]={["zone"]="Uldum",["type"]="Tol'vir"},
            ["Neferset Digsite"]={["zone"]="Uldum",["type"]="Tol'vir"},
            ["Steps of Fate Digsite"]={["zone"]="Uldum",["type"]="Tol'vir"},
            ["Temple of Uldum Digsite"]={["zone"]="Uldum",["type"]="Tol'vir"},
            ["Orsis Digsite"]={["zone"]="Uldum",["type"]="Tol'vir"},
            ["River Delta Digsite"]={["zone"]="Uldum",["type"]="Tol'vir"},
            ["Cursed Landing Digsite"]={["zone"]="Uldum",["type"]="Tol'vir"},
            ["Keset Pass Digsite"]={["zone"]="Uldum",["type"]="Tol'vir"},
            ["Akhenet Fields Digsite"]={["zone"]="Uldum",["type"]="Tol'vir"},
            ["Obelisk of the Stars Digsite"]={["zone"]="Uldum",["type"]="Tol'vir"},
            ["Sahket Wastes Digsite"]={["zone"]="Uldum",["type"]="Tol'vir"},
            ["Schnottz's Landing"]={["zone"]="Uldum",["type"]="Tol'vir"},
            ["Quagmire Fossil Field"]={["zone"]="Dustwallow Marsh",["type"]="Fossil"},
            ["Wyrmbog Fossil Field"]={["zone"]="Dustwallow Marsh",["type"]="Fossil"},
            ["Frostwhisper Gorge Digsite"]={["zone"]="Winterspring",["type"]="Night Elf"},
            ["Lake Kel'Theril Digsite"]={["zone"]="Winterspring",["type"]="Night Elf"},
            ["Owl Wing Thicket Digsite"]={["zone"]="Winterspring",["type"]="Night Elf"},
            ["Forest Song Digsite"]={["zone"]="Ashenvale",["type"]="Night Elf"},
            ["Ruins of Ordil'Aran"]={["zone"]="Ashenvale",["type"]="Night Elf"},
            ["Ruins of Stardust"]={["zone"]="Ashenvale",["type"]="Night Elf"},
            ["Zoram Strand Digsite"]={["zone"]="Ashenvale",["type"]="Night Elf"},
            ["Stonetalon Peak"]={["zone"]="Stonetalon Mountains",["type"]="Night Elf"},
            ["Ruins of Eldre'Thar"]={["zone"]="Stonetalon Mountains",["type"]="Night Elf"},
            ["Unearthed Grounds"]={["zone"]="Stonetalon Mountains",["type"]="Fossil"}
        }
        CurrentLookup = ContKLookup
    
    elseif (loc == ContEK) then
        local ContEKLookup = 
        {
            ["Vul'Gol Fossil Bank"]={["zone"]="Duskwood",["type"]="Fossil"},
            ["Twilight Grove Digsite"]={["zone"]="Duskwood",["type"]="Night Elf"},
            ["Greenwarden's Fossil Bank"]={["zone"]="Wetlands",["type"]="Fossil"},
            ["Thandol Span"]={["zone"]="Wetlands",["type"]="Dwarf"},
            ["Ironbeard's Tomb"]={["zone"]="Wetlands",["type"]="Dwarf"},
            ["Whelgar's Excavation Site"]={["zone"]="Wetlands",["type"]="Dwarf"},
            ["Eastern Zul'Mamwe Digsite"]={["zone"]="Stranglethorn Vale",["type"]="Troll"},
            ["Western Zul'Mamwe Digsite"]={["zone"]="Stranglethorn Vale",["type"]="Troll"},
            ["Bal'lal Ruins Digsite"]={["zone"]="Stranglethorn Vale",["type"]="Troll"},
            ["Balia'mah Ruins Digsite"]={["zone"]="Stranglethorn Vale",["type"]="Troll"},
            ["Western Ruins of Zul'Kunda Digsite"]={["zone"]="Stranglethorn Vale",["type"]="Troll"},
            ["Eastern Zul'Kunda Digsite"]={["zone"]="Stranglethorn Vale",["type"]="Troll"},
            ["Western Zul'Kunda Digsite"]={["zone"]="Stranglethorn Vale",["type"]="Troll"},
            ["Ziata'jai Digsite"]={["zone"]="Stranglethorn Vale",["type"]="Troll"},
            ["Savage Coast Raptor Fields"]={["zone"]="Stranglethorn Vale",["type"]="Fossil"},
            ["Nek'mani Wellspring Digsite"]={["zone"]="Stranglethorn",["type"]="Troll"},
            ["Ruins of Jubuwal"]={["zone"]="Stranglethorn",["type"]="Troll"},
            ["Ruins of Aboraz"]={["zone"]="Stranglethorn",["type"]="Troll"},
            ["Gurubashi Arena Digsite"]={["zone"]="Stranglethorn",["type"]="Troll"},
            ["Thoradin's Wall"]={["zone"]="Arathi Highlands",["type"]="Dwarf"},
            ["Witherbark Digsite"]={["zone"]="Arathi Highlands",["type"]="Troll"},
            ["Felstone Fossil Field"]={["zone"]="Western Plaguelands",["type"]="Fossil"},
            ["Northridge Fossil Field"]={["zone"]="Western Plaguelands",["type"]="Fossil"},
            ["Andorhal Fossil Bank"]={["zone"]="Western Plaguelands",["type"]="Fossil"},
            ["Infectis Scar Fossil Field"]={["zone"]="Eastern Plaguelands",["type"]="Fossil"},
            ["Quel'Lithien Lodge Digsite"]={["zone"]="Eastern Plaguelands",["type"]="Night Elf"},
            ["Zul'Mashar Digsite"]={["zone"]="Eastern Plaguelands",["type"]="Troll"},
            ["Terrorweb Tunnel Digsite"]={["zone"]="Eastern Plaguelands",["type"]="Nerubian"},
            ["Plaguewood Digsite"]={["zone"]="Eastern Plaguelands",["type"]="Nerubian"},
            ["Aerie Peak Digsite"]={["zone"]="Hinterlands",["type"]="Dwarf"},
            ["Shadra'Alor Digsite"]={["zone"]="Hinterlands",["type"]="Troll"},
            ["Altar of Zul Digsite"]={["zone"]="Hinterlands",["type"]="Troll"},
            ["Agol'watha Digsite"]={["zone"]="Hinterlands",["type"]="Troll"},
            ["Jintha'Alor Upper City Digsite"]={["zone"]="Hinterlands",["type"]="Troll"},
            ["Jintha'Alor Lower City Digsite"]={["zone"]="Hinterlands",["type"]="Troll"},
            ["Uldaman Entrance Digsite"]={["zone"]="Badlands",["type"]="Dwarf"},
            ["Hammertoe's Digsite"]={["zone"]="Badlands",["type"]="Dwarf"},
            ["Tomb of the Watchers Digsite"]={["zone"]="Badlands",["type"]="Dwarf"},
            ["Grim Batol Digsite"]={["zone"]="Twilight Highlands",["type"]="Dwarf"},
            ["Humboldt Conflagration Digsite"]={["zone"]="Twilight Highlands",["type"]="Dwarf"},
            ["Dunwald Ruins Digsite"]={["zone"]="Twilight Highlands",["type"]="Dwarf"},
            ["Thundermar Ruins Digsite"]={["zone"]="Twilight Highlands",["type"]="Dwarf"},
            ["Eastern Ruins of Thaurissan"]={["zone"]="Burning Steppes",["type"]="Dwarf"},
            ["Western Ruins of Thaurissan"]={["zone"]="Burning Steppes",["type"]="Dwarf"},
            ["Terror Wing Fossil Field"]={["zone"]="Burning Steppes",["type"]="Fossil"},
            ["Dun Garok Digsite"]={["zone"]="Hillsbrad Foothills",["type"]="Dwarf"},
            ["Southshore Fossil Field"]={["zone"]="Hillsbrad Foothills",["type"]="Fossil"},
            ["Pyrox Flats Digsite"]={["zone"]="Searing Gorge",["type"]="Dwarf"},
            ["Grimesilt Digsite"]={["zone"]="Searing Gorge",["type"]="Dwarf"},
            ["Misty Reed Fossil Bank"]={["zone"]="Swamp of Sorrows",["type"]="Fossil"},
            ["Sunken Temple Digsite"]={["zone"]="Swamp of Sorrows",["type"]="Troll"},
            ["Ironband's Excavation Site"]={["zone"]="Loch Modan",["type"]="Dwarf"},
            ["Lakeridge Highway Fossil Bank"]={["zone"]="Redridge Mountains",["type"]="Fossil"},
            ["Dreadmaul Fossil Field"]={["zone"]="Blasted Lands",["type"]="Fossil"},
            ["Red Reaches Fossil Bank"]={["zone"]="Blasted Lands",["type"]="Fossil"}
        }
       CurrentLookup = ContEKLookup
    
    elseif (loc == ContO) then
        local ContOLookup = 
        {
            ["Hellfire Basin Digsite"]={["zone"]="Hellfire Peninsula",["type"]="Orc"},
            ["Hellfire Citadel Digsite"]={["zone"]="Hellfire Peninsula",["type"]="Orc"},
            ["Sha'naar Digsite"]={["zone"]="Hellfire Peninsula",["type"]="Draenei"},
            ["Zeth'Gor Digsite"]={["zone"]="Hellfire Peninsula",["type"]="Orc"},
            ["Gor'gaz Outpost Digsite"]={["zone"]="Hellfire Peninsula",["type"]="Orc"},
            ["Twin Spire Ruins Digsite"]={["zone"]="Zangarmarsh",["type"]="Draenei"},
            ["Boha'mu Ruins Digsite"]={["zone"]="Zangarmarsh",["type"]="Draenei"},
            ["Bonechewer Ruins Digsite"]={["zone"]="Terokkar Forest",["type"]="Orc"},
            ["Bleeding Hollow Ruins Digsite"]={["zone"]="Terokkar Forest",["type"]="Orc"},
            ["Tuurem Digsite"]={["zone"]="Terokkar Forest",["type"]="Draenei"},
            ["Bone Wastes Digsite"]={["zone"]="Terokkar Forest",["type"]="Draenei"},
            ["East Auchindoun Digsite"]={["zone"]="Terokkar Forest",["type"]="Draenei"},
            ["West Auchindoun Digsite"]={["zone"]="Terokkar Forest",["type"]="Draenei"},
            ["Grangol'var Village Digsite"]={["zone"]="Terokkar Forest",["type"]="Orc"},
            ["Sunspring Post Digsite"]={["zone"]="Nagrand",["type"]="Orc"},
            ["Ancestral Grounds Digsite"]={["zone"]="Nagrand",["type"]="Orc"},
            ["Burning Blade Digsite"]={["zone"]="Nagrand",["type"]="Orc"},
            ["Laughing Skull Digsite"]={["zone"]="Nagrand",["type"]="Orc"},
            ["Halaa Digsite"]={["zone"]="Nagrand",["type"]="Draenei"},
            ["Illidari Point Digsite"]={["zone"]="Shadowmoon Valley",["type"]="Draenei"},
            ["Eclipse Point Digsite"]={["zone"]="Shadowmoon Valley",["type"]="Draenei"},
            ["Coilskar Point Digsite"]={["zone"]="Shadowmoon Valley",["type"]="Draenei"},
            ["Warden's Cage Digsite"]={["zone"]="Shadowmoon Valley",["type"]="Orc"},
            ["Ruins of Baa'ri Digsite"]={["zone"]="Shadowmoon Valley",["type"]="Draenei"},
            ["Dragonmaw Fortress"]={["zone"]="Shadowmoon Valley",["type"]="Orc"},
            ["Ruins of Enkaat Digsite"]={["zone"]="Netherstorm",["type"]="Draenei"},
            ["Ruins of Farahlon Digsite"]={["zone"]="Netherstorm",["type"]="Draenei"},
            ["Arklon Ruins Digsite"]={["zone"]="Netherstorm",["type"]="Draenei"}
        }
        CurrentLookup = ContOLookup        
    
    elseif (loc == ContN) then
        local ContNLookup = 
        {
            ["Talramas Digsite"]={["zone"]="Borean Tundra",["type"]="Nerubian"},
            ["En'kilah Digsite"]={["zone"]="Borean Tundra",["type"]="Nerubian"},
            ["Riplash Ruins Digsite"]={["zone"]="Borean Tundra",["type"]="Night Elf"},
            ["Sands of Nasam"]={["zone"]="Borean Tundra",["type"]="Nerubian"},
            ["Pit of Narjun Digsite"]={["zone"]="Dragonblight",["type"]="Nerubian"},
            ["Moonrest Gardens Digsite"]={["zone"]="Dragonblight",["type"]="Night Elf"},
            ["Voldrune Digsite"]={["zone"]="Grizzly Hills",["type"]="Vrykul"},
            ["Drakil'jin Ruins Digsite"]={["zone"]="Grizzly Hills",["type"]="Troll"},
            ["Baleheim Digsite"]={["zone"]="Howling Fjord",["type"]="Vrykul"},
            ["Wyrmskull Digsite"]={["zone"]="Howling Fjord",["type"]="Vrykul"},
            ["Gjalerbron Digsite"]={["zone"]="Howling Fjord",["type"]="Vrykul"},
            ["Halgrind Digsite"]={["zone"]="Howling Fjord",["type"]="Vrykul"},
            ["Nifflevar Digsite"]={["zone"]="Howling Fjord",["type"]="Vrykul"},
            ["Skorn Digsite"]={["zone"]="Howling Fjord",["type"]="Vrykul"},
            ["Shield Hill Digsite"]={["zone"]="Howling Fjord",["type"]="Vrykul"},
            ["Kolramas Digsite"]={["zone"]="Zul'Drak",["type"]="Nerubian"},
            ["Zol'Heb Digsite"]={["zone"]="Zul'Drak",["type"]="Troll"},
            ["Zim'Rhuk Digsite"]={["zone"]="Zul'Drak",["type"]="Troll"},
            ["Altar of Quetz'lun Digsite"]={["zone"]="Zul'Drak",["type"]="Troll"},
            ["Altar of Sseratus Digsite"]={["zone"]="Zul'Drak",["type"]="Troll"},
            ["Violet Stand Digsite"]={["zone"]="Crystalsong Forest",["type"]="Night Elf"},
            ["Ruins of Shandaral Digsite"]={["zone"]="Crystalsong Forest",["type"]="Night Elf"},
            ["Njorndar Village Digsite"]={["zone"]="Icecrown",["type"]="Vrykul"},
            ["Scourgeholme Digsite"]={["zone"]="Icecrown",["type"]="Nerubian"},
            ["Pit of Fiends Digsite"]={["zone"]="Icecrown",["type"]="Nerubian"},
            ["Jotunheim Digsite"]={["zone"]="Icecrown",["type"]="Vrykul"},
            ["Ymirheim Digsite"]={["zone"]="Icecrown",["type"]="Vrykul"},
            ["Brunnhildar Village Digsite"]={["zone"]="Storm Peaks",["type"]="Vrykul"},
            ["Valkyrion Digsite"]={["zone"]="Storm Peaks",["type"]="Vrykul"},
            ["Sifreldar Village Digsite"]={["zone"]="Storm Peaks",["type"]="Vrykul"}
        }    
        CurrentLookup = ContNLookup
    else
        -- unknown
        CurrentLookup = nil
    end
end

function ResetLocationsAndFlapper()

    local   buildArchLocations = (ArchLocations == nil or (getn(ArchLocations) == 0))    
    local   buildFlapperLocations = (FlapperLocations == nil or (getn(FlapperLocations) == 0))
        
    -- reset the map
    SetMapZoom(GetCurrentMapContinent()); 
       
    -- retrieve Archaeology locations (if required)
    if (buildArchLocations == true ) then    
        local num = GetNumMapLandmarks(); 
        for iz=1,num do 
            local name, description, textureIndex, x, y = GetMapLandmarkInfo(iz);
            if (textureIndex==ArchaeologyTextureIndex) and (buildArchLocations == true) then 
                if (name ~= nil) then                 
                    local site = {}                
                    site["name"] = name
                    site["x"] = x
                    site["y"] = y
                    table.insert(ArchLocations,site)
                end 
            end         
        end
    end
    
    if (buildFlapperLocations == true) then
            
        
        
        -- retrieve Flapper locations (if required)       
        for index,area in pairs(AreaLocations) do    
            
            SetMapZoom(GetCurrentMapContinent(),index);
                       
            local num = GetNumMapLandmarks();                                 
            for iLandmark=1,num do 
                local name, description, textureIndex, x, y = GetMapLandmarkInfo(iLandmark);
                

                if ((textureIndex == MFlapperTextureIndex) or 
                        (textureIndex == AFlapperTextureIndex)  or 
                        (textureIndex == HFlapperTextureIndex)) then
        
                    if (name ~= nil and area~=nil) then 
                        local flapper = {}
                        flapper["name"] = name                    
                        flapper["area"] = area
                        flapper["x"] = x
                        flapper["y"] = y

                        table.insert(FlapperLocations,flapper)
                    end                      
                end         
            end
        end
        
        -- reset the map
        SetMapZoom(GetCurrentMapContinent()); 
        
    end    
end

local function Diggz_ReloadLocations(self, ChatFrameOnly)

   local summary = "Archaeology Locations (Flight Points) in "
    -- reset the DiggzCount
   self.DiggzTextArray = {}
   local loc = Diggz_WhereAmI()
   
   if (loc == nil) then
   
        summary = string.format("%sUnknown",summary)
   else
        summary = string.format("%s%s",summary,loc)
        
        table.insert(self.DiggzTextArray,summary)

        -- see if we need to reload the tables
        if (CurrentLookup == nil) or (CurrentContinent ~=  loc) then
            -- load the required table
            NewLookup(loc)
            
            -- update the value of CurrentLookup
            CurrentContinent = loc                             
            
            -- update the areas for the map
            AreaLocations = {}                    
            local continent = GetCurrentMapContinent()
            local zones = {GetMapZones(continent)}
            for idx,zone in ipairs(zones) do
                table.insert(AreaLocations,zone)      
            end                    
            
            -- if the area has been re-read, you'll need to re-read the flapper locations
            FlapperLocations = {}  
            
        end       
        
        -- new locations
        ResetLocationsAndFlapper()            
        
        for key,location in pairs(ArchLocations) do                
            local lname = location["name"]
            
            local site = CurrentLookup[lname ]
            if (site == nil) then
                print ("Unknown area: ",lname);
            else
                local SpecificRace = site["type"]
    
                if (SpecificRace == nil) then
                    print (string.format("Unknown location: %s",lname ))
                else
                    local raceCount = GetNumArchaeologyRaces();
                    local SpecificZone = site["zone"]
                    local SpecificX = location["x"]
                    local SpecificY =location["y"]        

                    for i=1,raceCount do 
                        local siteInfo = Diggz_DescribeSite(i,SpecificRace,SpecificZone,SpecificX,SpecificY)
                        if (siteInfo ~= nil) then
                            -- add the required summary
                            table.insert(self.DiggzTextArray,siteInfo)
                        end
                    end        
                end
            end                
        end        
    end
    
    if not (ArchLocations == nil or getn(ArchLocations) == 0) then
        if ChatFrameOnly == true then               
            DEFAULT_CHAT_FRAME:AddMessage(summary)
        else
                      
            local lSummary  = ""
            for mkey,mlocation in pairs(self.DiggzTextArray) do     
                lSummary = lSummary .. mlocation .. "|n"
            end

            DiggzText:SetText(lSummary)
        end        
    end
end

function DiggzFrame_OnEvent(self, event, ...)
    if      (event == "PLAYER_ENTERING_WORLD")  or 
            (event == "ZONE_CHANGED_NEW_AREA") then
                ArchLocations = {}                      
                Diggz_ReloadLocations(self,false)
                
    elseif (event == "ARTIFACT_COMPLETE") or
           (event == "ARTIFACT_DIG_SITE_UPDATED")then        
                ArchLocations = {}            
                Diggz_ReloadLocations(self,false)
                
    elseif (event == "CURRENCY_DISPLAY_UPDATE") then        
                Diggz_ReloadLocations(self,false)
    end       
end

function Diggz_Hyp(srcX, srcY, destX, destY)    
    return math.sqrt(math.pow(srcX-destX,2) + math.pow(srcY-destY,2))
end

function Diggz_DescribeSite(raceIndex, SpecificRace, SpecificZone,SpecificX,SpecificY)
    local DiggzStatus = nil
    if (raceIndex ~= nil) then
        local raceName, raceTexture, raceItemID, numFragmentsCollected, numFragmentsRequired = GetArchaeologyRaceInfo(raceIndex)
        if (raceName ~= "Other") then
            if (SpecificRace == raceName) then

                local closestFlapper = nil                    
                local smallestHyp = nil
                
                for fp,zonevalue in pairs(FlapperLocations) do 
                    if (string.find(zonevalue["name"],SpecificZone) ~= nil) then
                        if (closestFlapper == nil) then
                            closestFlapper = zonevalue["name"]
                            smallestHyp = Diggz_Hyp(SpecificX,SpecificY,zonevalue["x"],zonevalue["y"])
                        else
                            local tempHyp = Diggz_Hyp(SpecificX,SpecificY,zonevalue["x"],zonevalue["y"])
                            
                            if (tempHyp <= smallestHyp) then 
                                closestFlapper = zonevalue["name"]
                                smallestHyp = tempHyp
                            end
                        end
                    end
                end
               
                if (closestFlapper == nil) then
                    DiggzStatus = string.format("%s[%d/%d](Somewhere in %s)",raceName,numFragmentsCollected,numFragmentsRequired,SpecificZone)
                else
                    DiggzStatus = string.format("%s[%d/%d](%s)",raceName,numFragmentsCollected,numFragmentsRequired,closestFlapper)
                end         
            end
        end
    end
    
    return DiggzStatus
end

function Diggz_Slash_Command(command)
    local command = strlower(command)
    
    if strlen(command) == 0 then
        DEFAULT_CHAT_FRAME:AddMessage("Diggz prompt: /diggz <option> or /dz <option>,\n\t 'show' - Show Diggz window\n\t'hide' - Hide Diggz window")     
    else    
--        if string.find(commandLower,"hide") >0  then
--            DiggzEnabled = false
--            DEFAULT_CHAT_FRAME:AddMessage("Diggz is now disabled")
--        end
--        if string.find(commandLower,"show") >0  then
--            DiggzEnabled = true
 --       end
        if string.find(commandLower,"current") >0  then
            -- reload
            ArchLocations = {}                      
            Diggz_ReloadLocations(self,true)
        end
    end
end

function Diggz_CollapseExpandButton_OnClick(self)    
    if (DiggzText:IsShown()) then       
        DiggzFrame:SetHeight(12)        
        DiggzText:SetHeight(0)            

        DiggzText:Hide()        
        PlaySound("igMiniMapClose");    		
	else        
        DiggzFrame:SetHeight(6 * 12)        
        DiggzText:SetHeight(5 * 12)            

		DiggzText:Show()    
        PlaySound("igMiniMapOpen");
	end
end

function DiggzFrame_OnLoad(self)
    self:RegisterEvent("PLAYER_ENTERING_WORLD")
    self:RegisterEvent("ARTIFACT_COMPLETE")
    self:RegisterEvent("ARTIFACT_DIG_SITE_UPDATED")
    self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
    self:RegisterEvent("CURRENCY_DISPLAY_UPDATE")
    
    SlashCmdList["DIGGZ"] = Diggz_Slash_Command;
	SLASH_DIGGZ1 = "/diggz";
	SLASH_DIGGZ2 = "/dz";
    
    -- Indicate version at load time
    DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffffffDiggz|cffff9900 %s|cffffffff loaded", tostring(GetAddOnMetadata("Diggz","Version")))) 
end

